#ifndef INC_ANIM_H
#define INC_ANIM_H

#include "coord.h"
#include "glyph.h"

struct FrameSquare {
    Coord pos;
    Glyph glyph;
    FrameSquare(Coord pos, Glyph glyph) : pos(pos), glyph(glyph) {}
    FrameSquare(Coord pos);
};

struct AnimFrame : public vector<FrameSquare> {
    bool cleanAfter;
    void draw();
    void clearUp();
    AnimFrame(bool cleanAfter=false) : cleanAfter(cleanAfter) {}
};

const float STANDARD_PAUSETIME = 0.2;

struct Anim : public vector<AnimFrame> {
    float pauseTime; // in seconds
    void draw();
    void addToCurrentFrame(const FrameSquare& fs);
    void newFrame(bool cleanAfter=false) {
	push_back(AnimFrame(cleanAfter)); }
    Anim(float pauseTime=STANDARD_PAUSETIME) : pauseTime(pauseTime) {}
};

extern Anim anim;

#endif /* INC_ANIM_H */
