#ifndef INC_CRITTERTYPE_H
#define INC_CRITTERTYPE_H

#include "glyph.h"

struct CritterType {
    Glyph glyph;
    const char* description;

    bool flying;
    bool unstunnable;
    bool slow;

    int congregateChance;
    int wallHugChance;
    int wanderChance;
    int visionRange;

    Glyph offturnGlyph;

    CritterType(Glyph glyph=Glyph('?'), const char* description="BUG",
	    bool flying=false, bool unstunnable=false, bool slow=false,
	    int congregateChance=0, int wallHugChance=0, int wanderChance=10,
	    int visionRange=7, Glyph offturnGlyph=Glyph('?')) :
	glyph(glyph), description(description),
	flying(flying), unstunnable(unstunnable), slow(slow),
	congregateChance(congregateChance), wallHugChance(wallHugChance),
	wanderChance(wanderChance), visionRange(visionRange),
	offturnGlyph(offturnGlyph) {}
};

extern const CritterType dumbCrawler;
extern const CritterType skittishFlyer;
extern const CritterType toughShambler;
#endif /* INC_CRITTERTYPE_H */
