#include <string.h>
#include <curses.h>

#include "info.h"
#include "glyph.h"
#include "coord.h"
#include "player.h"

void InfoPanel::draw() {
    int y=screenTopleft.y + (std::max(0,h/2 - 2));
    int x=screenTopleft.x;
    char buf[10];

    if (h < 4)
	return;

    int b = player.selectedBranch;
    BranchStatus* bs = NULL;
    if (b > -1)
	bs = &player.branchStati[b];

    attrset(0);

    snprintf(buf, w, "Shld: %d", player.hp);
    mvaddstr(y++, x, buf);
    clrtoeol();

    snprintf(buf, w, "Chrg: %d", player.energy);
    mvaddstr(y++, x, buf);
    if (bs && (bs->energy < player.maxenergy || player.energy < player.maxenergy)) {
	int l = strlen(buf);
	snprintf(buf, w, "%d", bs->energy);
	attrset(attrOfCol(player.branchGlyph(b).col));
	mvaddstr(y-1, x+l+1, buf);
	attrset(0);
    }
    clrtoeol();

    if (player.fuel) {
	snprintf(buf, w, "Fuel: %d", player.fuel);
	mvaddstr(y++, x, buf);
	if (bs && (bs->fuel != player.fuel)) {
	    int l = strlen(buf);
	    snprintf(buf, w, "%d", bs->fuel);
	    attrset(attrOfCol(player.branchGlyph(b).col));
	    mvaddstr(y-1, x+l+1, buf);
	    attrset(0);
	}
	clrtoeol();
    }

    snprintf(buf, w, "Lag : %d", player.lag);
    mvaddstr((y++), x, buf);
    clrtoeol();

    if (!player.fuel) {
	move(y,x);
	clrtoeol();
    }

    /*
    snprintf(buf, 10, "AutF: %c", player.autofiring?'Y':'N');
    mvaddstr(y+3, x, buf);
    if (bs && bs->autofiring != player.autofiring) {
	int l = strlen(buf);
	snprintf(buf, 10, "%c", bs->autofiring?'Y':'N');
	attrset(attrOfCol(player.branchGlyph(b).col));
	mvaddstr(y+3, x+l+1, buf);
	attrset(0);
    }
    clrtoeol();
    */
    refresh();
}
void HelpPanel::draw() {
    int y=screenTopleft.y;
    int x=screenTopleft.x;

    attrset(0);
    if (h > 11)
	mvaddstr(y++,x,"   Keys   ");
    if (h >= 11) {
#ifndef DVORAK
	mvaddstr(y++,x,"yku   789");
	mvaddstr(y++,x,"h.l   456");
	mvaddstr(y++,x,"bjn   123");
#else
	mvaddstr(y++,x,"gnc   789");
	mvaddstr(y++,x,"h.s   456");
	mvaddstr(y++,x,"btm   123");
#endif
    }
    if (h > 12)
	y++;
    if (h >= 8) {
	mvaddstr(y++,x,"f:Fire");
	mvaddstr(y++,x,"r:Run");
	mvaddstr(y++,x,"a:Autofire");
	mvaddstr(y++,x,"p:chkPath");
#ifndef DVORAK
	mvaddstr(y++,x,"c:reCharge");
#else
	mvaddstr(y++,x,"e:rEcharge");
#endif
	mvaddstr(y++,x,"x:eXamine");
	mvaddstr(y++,x,"v:View lag");
	mvaddstr(y++,x,"q:Quit");
    }
    refresh();
}

void Indicators::draw() {
    if( !goalSet )
	goalSet = player.setGoal(&goal);
    if( goalSet ) {
	Coord goalDir = dirTowards(goal - player.getPos());
	for (vector<Coord>::iterator dir = dirs.begin(); dir != dirs.end(); dir++) {
	    int x = (dir->x == 1 ? e.x : dir->x == -1 ? s.x : (e.x+s.x)/2 );
	    int y = (dir->y == 1 ? e.y : dir->y == -1 ? s.y : (e.y+s.y)/2 );
	    char c = *dir == goalDir ? '*' : ' ';
	    attrset(attrOfCol(B_RED));
	    mvaddch(y,x,c);
	}
    }
}
