#include <string.h>
#include <curses.h>
using namespace std;

#include "messages.h"


void Messages::draw() {
    if (newMessage || oldMessage)
	redraw();
}

void Messages::redraw() {
    int n=0;
    for (vector<Message>::reverse_iterator m = log.rbegin(); m != log.rend() && n<h; m++) {
	attrset(m->attr);
	if (newMessage && n==0)
	    attron(A_BOLD);
	else
	    attroff(A_BOLD);
	mvaddstr(line+n, 0, m->s.c_str());
	clrtoeol();
	n++;
    }
    oldMessage = false;
    if (newMessage) {
	newMessage = false;
	oldMessage = true;
    }
    refresh();
}

void Messages::clearBox() {
    for (int j=0; j<h; j++) {
	move(line+j,0);
	clrtoeol();
    }
}

void Messages::add(const Message& message) {
    log.push_back(message);
    newMessage = true;
}
Message::Message(const char* format, va_list argp)
{
    static const int maxlen = 300;
    char buffer[maxlen];

    vsnprintf(buffer, maxlen, format, argp);
    s = string(buffer);
    attr = 0;
}
Message::Message(int col, const char* format, va_list argp)
{
    static const int maxlen = 300;
    char buffer[maxlen];

    vsnprintf(buffer, maxlen, format, argp);
    s = string(buffer);
    attr = attrOfCol(col);
}
