#ifndef INC_TILE_H
#define INC_TILE_H

#include <curses.h>

#include "glyph.h"

enum Tile {
    TILE_NULL,
    TILE_WALL,
    TILE_FLOOR1,
    TILE_FLOOR2,
    TILE_FLOOR3,
    TILE_FLOOR4,
    TILE_FLOOR_END,
    TILE_SURFACE,
    TILE_CAVE_ENTRANCE,
    TILE_EXIT,
    TILE_LAVA,
    TILE_HIGH,
    TILE_LOW,
    NUM_TILES
};

bool floorTile(Tile t);

struct TileDef {
    const Glyph glyph;
    bool passable;
    bool transparent;
    const char* description;
    int cliff; // 0: no cliff; -1: foot of cliff; 1: top of cliff
    TileDef(Glyph glyph, bool passable=true, bool transparent=true, const char* description="", int cliff=0) :
	glyph(glyph), passable(passable), transparent(transparent), description(description), cliff(cliff) {}
};

TileDef tileDefOfTile(Tile tile);

#endif /* INC_TILE_H */
