#ifndef INC_VIEW_H
#define INC_VIEW_H

#include <set>
using namespace std;

#include "coord.h"
#include "glyph.h"

class Cave;

class View {
    protected:
	Coord screenTopleft;
	Coord viewTopleft;
	int focusrad;
	set<Coord> dirty;

	void drawCell(Coord cc);
	void drawInCell(Glyph glyph, Coord cc);

    public:
	int w;
	int h;

	virtual Glyph getGlyph(const Coord& c) = 0;

	View(int w, int h, Coord screenTopleft, Coord viewTopleft, int focusrad=0)
	    : screenTopleft(screenTopleft),
	    viewTopleft(viewTopleft), focusrad(focusrad), w(w), h(h) {}
	void setFocus(Coord c, bool conservative=false);
	void setDirty(Coord c);
	void drawDirty();
	void drawAll();
	void drawAtPos(Glyph glyph, Coord c);
	void refreshView();
	virtual ~View() {}
};

class GameView : public View {
    Cave* cave;
    public:
	Glyph getGlyph(const Coord& c);
	void setGeom(int i_w, int i_h, Coord i_screenTopleft) {
	    w=i_w; h=i_h; screenTopleft=i_screenTopleft; drawAll(); }
	GameView(Cave* cave, Coord viewTopleft, int focusrad=0)
	    : View(w, h, screenTopleft, viewTopleft, focusrad), cave(cave) {}
};

extern GameView gameView;

int firstMessageLine(int h);
void setGeometry();

#endif /* INC_VIEW_H */
